/*
 * @Description: 测试车位分配模块通信情况
 * @Author: yct
 * @Date: 2020-07-08 15:51:46
 * @LastEditTime: 2020-07-24 10:54:17
 * @LastEditors: yct
 */ 
#include "../parkspace_allocation/parkspace_communicator.h"
#include "../parkspace_allocation/parkspace_manager.h"

#include "database_controller.h"


int main()
{
	//huli 20210129
	//20200129test
    google::InitGoogleLogging("parkspace_allocator");
    google::SetStderrLogging(google::INFO);
    google::InstallFailureSignalHandler();
    FLAGS_colorlogtostderr = true;

    Parkspace_communicator *p_parkspace_allocation_communicater = Parkspace_communicator::get_instance_pointer();
    Parkspace_manager *p_parkspace_manage = Parkspace_manager::get_instance_pointer();


//    parkspace_proto::database_config config;
//    config.set_db_ip("127.0.0.1");
//    config.set_db_port(3306);
//    config.set_db_username("wk");
//    config.set_db_passwd("123456");
//    config.set_db_name("test");
//    config.set_db_conn_pool_size(5);
//    p_parkspace_allocator->parkspace_allocator_init(4, config);
//
//	Database_controller::get_instance_references().database_controller_init();


	Database_controller::get_instance_pointer()->database_controller_init("127.0.0.1", 3306, "wk", "123456", "test");
//	Database_controller::get_instance_pointer()->database_controller_init("127.0.0.1", 3306, "wk", "123456", "test");

//
    p_parkspace_allocation_communicater->communication_connect("tcp://192.168.10.210:30000");
//    p_parkspace_allocation_communicater->communication_bind("tcp://192.168.10.210:30005");
	p_parkspace_allocation_communicater->communication_bind("tcp://192.168.1.38:30005");
    p_parkspace_allocation_communicater->communication_run();
//
//
	p_parkspace_manage->parkspace_manager_init(4);

    // // 初始化车位，创建三个车位
    // message::Parkspace_allocation_status_msg parkspace_status;
    // for (size_t i = 1; i < 1000; i++)
    // {
    //     message::Parkspace_info* space = parkspace_status.add_parkspace_info();
    //     space->set_parkspace_id(i);
    //     space->set_index(i);
    //     space->set_direction(message::Direction::eForward);
    //     space->set_floor(2+i);
    //     space->set_length(5.5);
    //     space->set_width(2.2);
    //     space->set_height(1.75);
    //     space->set_parkspace_status(message::Parkspace_status::eParkspace_empty);
    // }
    // message::Base_info base_msg;
    // message::Error_manager error;
    // base_msg.set_msg_type(message::Message_type::eParkspace_allocation_response_msg);
    // base_msg.set_timeout_ms(1000);
    // base_msg.set_sender(message::Communicator::eParkspace);
    // base_msg.set_receiver(message::Communicator::eMain);
    // error.set_error_code(0);
    // parkspace_status.mutable_base_info()->CopyFrom(base_msg);
    // parkspace_status.mutable_error_manager()->CopyFrom(error);
    // p_parkspace_allocation_communicater->update_parkspace_status(parkspace_status);
    int k=1;

    while(1) {
        // message::Parkspace_info space;
        // space.set_parkspace_id(3);
        // space.set_index(k);
        // space.set_direction(message::Direction::eForward);
        // space.set_floor(k*3);
        // space.set_length(5500);
        // space.set_width(2200);
        // space.set_height(k*400);
        // space.set_parkspace_status(message::Parkspace_status::eParkspace_occupied);
        // p_parkspace_allocator->update_parkspace_status(3, space);
        usleep(1000*1000);
        k++;
    }
	Database_controller::get_instance_pointer()->database_controller_uninit();
    return 0;
}
